﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace USBPhysic_Example
{
    public partial class Form1 : Form
    {
        //load the library
        [DllImport("USBPhysic")]
        public static extern int Init(string sUser, string sRegCode);

        [DllImport("USBPhysic")]
        public static extern int GetUSBPhysicInfo(int diskIndex, int InfoType, StringBuilder pHddInfo);

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            const int nChars = 1024;
            StringBuilder Buff = new StringBuilder(nChars);
            
            //0 = Get SerialNumber
            if (GetUSBPhysicInfo(Int32.Parse(comboBox1.Items[comboBox1.SelectedIndex].ToString()), 0, Buff) > 0)
                textBox1.Text = Buff.ToString();
            else
                textBox1.Text = "n/a";

            //1 = Get product name
            if (GetUSBPhysicInfo(Int32.Parse(comboBox1.Items[comboBox1.SelectedIndex].ToString()), 1, Buff) > 0)
                textBox2.Text = Buff.ToString();
            else
                textBox2.Text = "n/a";

            //2 = Get USB Manufacturer
            if (GetUSBPhysicInfo(Int32.Parse(comboBox1.Items[comboBox1.SelectedIndex].ToString()), 2, Buff) > 0)
                textBox3.Text = Buff.ToString();
            else
                textBox3.Text = "n/a";

            //3 = Get drive letter mapped on Windows
            if (GetUSBPhysicInfo(Int32.Parse(comboBox1.Items[comboBox1.SelectedIndex].ToString()), 3, Buff) > 0)
                textBox4.Text = Buff.ToString();
            else
                textBox4.Text = "n/a";
            
        }

        private void label8_Click(object sender, EventArgs e)
        {
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int USBDisks = Init("your reg code here", "your reg code here");

            if (USBDisks > 0)
            {
                for (int i = 0; i < USBDisks; i++)
                {
                    comboBox1.Items.Add(i);
                }
                comboBox1.SelectedIndex = 0;
            }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("IExplore", " http://www.rlbyte.com");
        }
    }
}
